QGIS Application - Bug report #13731
DBManager's Oracle SQL Query "load result as new layer" gives and error
2015-11-02 02:58 AM - Mehmet Selim BILGIN

Status: Closed

Priority: High

Assignee:

Category: DB Manager

Affected QGIS version:2.12.0 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 21758
Description

In QGIS 2.12 when using DBManager plugin with Oracle tables this bug occurs. | ran a simple SQL query like SELECT * FROM ilceler it
returned the results succesfully. And than i clicked Load as new layer button to see results in QGIS canvas it gave error. The error says
the reason is: ORA-00933: SQL command not properly ended. Also it gives the SQL query: SELECT * FROM (select * from ilceler
)JAS" subQuery 0" LIMIT 0. | only entered SELECT * FROM ilceler. DBManager changed the original query so it throws error.

Associated revisions

Revision e04d5e4d - 2015-11-17 09:29 PM - Sebastian Dietrich

replaced 'LIMIT 0' by 'WHERE 0=1" (fixes #13731)

Revision 57f5fba5 - 2015-11-17 11:08 PM - Jiirgen Fischer

Merge pull request #2478 from SebDieBIn/DbManager_Fix13731

[DbManager] replaced 'LIMIT 0' by 'WHERE 0=1' (fixes #13731)

Revision 5d359a63 - 2015-11-18 09:25 AM - Sebastian Dietrich

replaced 'LIMIT 0' by 'WHERE 0=1" (fixes #13731)

Revision c2fb11c8 - 2015-12-02 09:24 AM - Jiirgen Fischer

db manager: only alias subqueries on postgres (fixes #13731)

Revision 80c5cb68 - 2015-12-08 03:42 PM - Jiirgen Fischer
db manager: only alias subqueries on postgres (fixes #13731)
Conflicts:

python/plugins/db_manager/dlg_sql_window.py

History

#1 - 2015-11-06 01:35 AM - Giovanni Manghi
- Subject changed from 2.12 DBManager's Oracle SQL Query result as new layer error | to DBManager's Oracle SQL Query "load result as new layer"
gives and error

- Target version deleted (Version 2.12)

- OS version deleted (2.12)

#2 - 2015-11-16 09:25 AM - René-Luc ReLuc

- Priority changed from Normal to High

It's a known issue.

In the TODO list of the oracle's db_manager plugin, we can find :

- SQL Window - Can't retrieve column: dig_sql_window.py launch an invalid request for Oracle (no LIMIT operator in Oracle). Should patch

dlg_sql_window.py to use a connector method to grab columns.

https://github.com/qgis/QGIS/blob/master/python/plugins/db_manager/db_plugins/oracle/TODO.md

#3 - 2015-11-17 12:43 PM - Sebastian Dietrich

Please see PR 2478 for a simple solution (replacing LIMIT 0 with WHERE 0=1) of this issue, that is actually in the won't fix section of the mentioned
TODO.

#4 - 2015-11-17 02:08 PM - Jiirgen Fischer
- Status changed from Open to Closed

Fixed in changeset commit:"57f5fba5823e318809aa409a77ae636ea12874f5".

#5 - 2015-11-18 12:27 AM - René-Luc RelLuc

I'll backport commit:5d359a6 to release-2_12 if a 2.12.1 will be released.

#6 - 2015-12-01 12:47 AM - René-Luc ReLuc
- Status changed from Closed to Reopened

commit:57f5fba does not fixed it.

It seems that the 'AS' is not supported in Oracle. Some one can confirm it ?

#7 - 2015-12-01 01:03 AM - René-Luc ReLuc

Oracle does not support AS for aliases table name. It seems that in PostgreSQL and SQLite, it's not mandatory.

| proposed to remove it. Some objection ?

#8 - 2015-12-01 06:35 AM - Jukka Rahkonen
Works for me from Oracle Database 12c Enterprise Edition Release 12.1.0.2.0 - 64bit Production:

SELECT attribute AS test FROM test_table;

This diagram shows also AS in quite many places http://docs.oracle.com/cd/B19306_01/server.102/b14200/statements_10002.htm.

Could you show example SQL where AS is not supported?

#9 - 2015-12-01 06:44 AM - René-Luc ReLuc

It seems to not worked for table name aliases.

This does not work:

SELECT * FROM (select * fromilceler) AS "_subQuery__0".

This works:

SELECT * FROM (select * from ilceler) "_subQuery__ 0"

In the documentation, the "AS" seems to be not used for table aliases (search for t_alias in
http://docs.oracle.com/cd/B19306_01/server.102/b14200/statements_10002.htm).

#10 - 2015-12-02 12:29 AM - Jiirgen Fischer

- Status changed from Reopened to Closed

Fixed in changeset commit:"c2fb11c8d5fba163068d7ea87aal1062035dd167".
